<script lang="ts">
  import cardEmoji from "./cardEmoji";
  import type { CardId } from "../server";
  import type { CardFace } from "../server";
  import {
    cardDescription,
    cardFace,
    cardTitle,
    cardValue,
  } from "./util/cardUtils";

  export let card: CardId | CardFace;

  $: face = typeof card === "string" ? card : cardFace(card);
  $: value = cardValue(face);
  $: description = cardDescription(face);
  $: title = cardTitle(face);
  $: emoji = cardEmoji(face);
</script>

<div class="wrapper border shadow">
  <div class="value">{value}</div>
  <div class="title">{title}</div>
  <div class="portrait emoji">{emoji}</div>
  <div class="description">{description}</div>
</div>

<style>
  .wrapper {
    position: relative;
    background: radial-gradient(linen, rgb(255, 243, 232));
    padding: 0.75em;
    height: 14em;
    width: 10em;
    border-radius: 1em;
  }
  .value {
    position: absolute;
    font-family: Georgia, "Times New Roman", Times, serif;
    font-size: 2.8em;
    top: 0;
  }
  .title {
    text-align: center;
    font-family: "Berkshire Swash", cursive;
    font-size: 1.25em;
    margin-left: 1em;
  }
  .portrait {
    position: absolute;
    left: 50%;
    top: 40%;
    transform: translate(-50%, -50%);
    font-size: 3.5em;
  }
  .description {
    position: absolute;
    top: 55%;
    bottom: 0;
    left: 0;
    right: 0;

    padding: 2em;
    text-align: center;
    font-family: Georgia, "Times New Roman", Times, serif;
    font-size: 0.6em;
  }
</style>
